
#include "unix.h"

typedef struct _Point {
    float x, y, z;
} Point;


Ellipsoid( xaxis, yaxis, zaxis, center, n1, n2, depth, clockwise, primitive )
float xaxis, yaxis, zaxis;
Point center;
int n1, n2, depth;
char clockwise;
int primitive;
{
    int i, j;        /* i/phi    j/theta */
    float is, js;
    float phi, theta, step;
    float fphiSize, fthetaSize;
    int phiSize, thetaSize;
    Point ellipsoid[130][260];
    FILE *fp;
    extern char *filename;

    fp = fopen( filename, "w" );

    step = (float)(M_PI / pow( (double)2, (double)depth ));
    fphiSize = (M_PI / step) + 1.;
    fthetaSize = (2 * M_PI / step) + 1.;
    phiSize = (int)fphiSize;
    thetaSize = (int)fthetaSize;

    for( i = 0; i < phiSize; i++ ) {
        for( j = 0; j < thetaSize; j++ ) {
            is = -(M_PI/2.) + i * step;   js = -M_PI + j * step;
            ellipsoid[i][j].x = xaxis * pow( cos( is ), (double)n1 )
                                      * pow( cos( js ), (double)n2 ) + center.x;
            ellipsoid[i][j].y = yaxis * pow( cos( is ), (double)n1 )
                                      * pow( sin( js ), (double)n2 ) + center.y;
            ellipsoid[i][j].z = zaxis * pow( sin( is ), (double)n1 ) + center.z;
        }
    }

    fprintf( fp, "%d\t%d\t%d\n", phiSize * thetaSize,
                 (phiSize-1) * (thetaSize-1), 4 * (phiSize-1) * (thetaSize-1) );

    /* Print the Coordinates of the points */
    for( i = 0; i < phiSize; i++ ) {
        for( j = 0; j < thetaSize; j++ ) {
            fprintf( fp, "%f %f %f\n", ellipsoid[i][j].x, ellipsoid[i][j].y,
                                       ellipsoid[i][j].z );
        }
    }

    /* Print the Conectivity data of the points */
    if( !clockwise ) {    /* counterClockwise */
        for( i = 0; i < thetaSize-1; i++ ) {
            for( j = 0; j < phiSize-1; j++ ) {
                fprintf( fp, "4 %d %d %d %d\n",
                           j*thetaSize+i+1,         j*thetaSize+(i+1)+1,
                       (j+1)*thetaSize+(i+1)+1, (j+1)*thetaSize+i+1 );
            }
        }
    }
    else {
        for( i = 0; i < thetaSize-1; i++ ) {
            for( j = 0; j < phiSize-1; j++ ) {
                fprintf( fp, "4 %d %d %d %d\n",
                           j*thetaSize+i+1, (j+1)*thetaSize+i+1,
                   (j+1)*thetaSize+(i+1)+1, j*thetaSize+(i+1)+1 );
            }
        }
    }
    fclose( fp );
}
